<template>
  <div class="app-container">
    <el-row>
      <el-col :span="24">
        <div>
          <el-radio-group v-model="enable">
            <el-radio-button label="ALL">全部</el-radio-button>
            <el-radio-button label="true">激活</el-radio-button>
            <el-radio-button label="false">未激活</el-radio-button>
          </el-radio-group>
        </div>
      </el-col>
    </el-row>
    <BR />
    <el-row>
      <el-col :span="24">
        <div>
          <el-button @click="queryAction">查詢</el-button>
          <el-button>重置</el-button>
          <el-button @click="reportAction">報表</el-button>
        </div>
      </el-col>
    </el-row>
    <el-divider>查詢結果</el-divider>
    <el-table :data="dataTable">
      <el-table-column prop="role" label="角色代碼" />
      <el-table-column prop="name" label="角色名稱" />
      <el-table-column prop="def" label="角色敘述" />
      <el-table-column prop="enabled" :formatter="enabledFormatter" label="激活狀態" />
      <el-table-column label="編輯" fixed="left" width="100">
        <template slot-scope="scope">
          <el-button @click="dialogAction(scope.row)">編輯</el-button>
        </template>
      </el-table-column>
    </el-table>

    <el-dialog title="角色編輯" :visible.sync="dialogFormVisible" :close-on-click-modal="false">
      <el-form ref="dataDialog" :model="dataDialog" :rules="rule" label-width="100px">
        <el-form-item label="角色代碼" prop="role">
          <el-input v-model="dataDialog.role" disabled />
        </el-form-item>
        <el-form-item label="角色名稱" prop="name">
          <el-input v-model="dataDialog.name" />
        </el-form-item>
        <el-form-item label="角色敘述" prop="def">
          <el-input v-model="dataDialog.def" />
        </el-form-item>
        <el-form-item label="激活狀態" prop="enabled">
          <el-radio-group v-model="dataDialog.enabled">
            <el-radio :label="true">激活</el-radio>
            <el-radio :label="false">未激活</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="deleteAction">刪除</el-button>
        <el-button @click="updateAction">更新</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import { query, update, del, report } from './action'
import { insertFormRules } from './rule'
export default {
  data() {
    return {
      enable: 'ALL',
      dataTable: [],
      dataDialog: [],
      dialogFormVisible: false,
      rule: insertFormRules()
    }
  },
  methods: {
    reportAction: function() {
      report({ enable: this.enable }).then(res => {
        const blob = new Blob([res.data], { type: res.data.type })
        /* const link = document.createElement('a')
        link.href = window.URL.createObjectURL(blob)
        link.download = res.headers.filename
        link.click()*/
        const DATA_URI = window.URL.createObjectURL(blob)
        window.open(DATA_URI)
      })
    },
    deleteAction: function() {
      del(this.dataDialog.role).then(res => {
        if (res.status === 'OK') {
          alert(res.message)
          this.queryAction()
          this.dialogFormVisible = false
          this.dataDialog = []
        } else {
          alert('刪除失敗!')
        }
      })
    },
    updateAction: function() {
      update(this.dataDialog).then(res => {
        if (res.status === 'OK') {
          alert(res.message)
          this.queryAction()
        } else {
          alert('更新失敗!')
        }
      })
    },
    dialogAction: function(row) {
      this.dataDialog = Object.assign({}, row)
      this.dialogFormVisible = true
    },
    enabledFormatter: function(row, col) {
      return row.enabled === true ? '已激活' : '未激活'
    },
    queryAction: function() {
      query({ enable: this.enable }).then(res => {
        if (res.status === 'OK') {
          this.dataTable = res.data
        }
      })
    }
  }
}
</script>
